/// <reference types="sequelize" />
import * as Sequelize from 'sequelize';
import { SpecType } from 'pretur.spec';
import { Query, MutateRequest } from 'pretur.sync';
import { ResolveResult } from './resolver';
import { SyncResult } from './synchronizer';
import { Provider } from './provider';
export declare type Transaction = Sequelize.Transaction;
export interface ProviderMap {
    [scope: string]: {
        [model: string]: Provider<any>;
    };
}
export interface ProviderPool<M extends ProviderMap = ProviderMap> {
    providers: M;
    resolve<T extends SpecType>(transaction: Transaction, scope: string, model: T['name'], query: Query<T>, context?: any): Promise<ResolveResult<T>>;
    sync<T extends SpecType>(transaction: Transaction, item: MutateRequest<T>, context?: any): Promise<SyncResult<T>>;
    initialize(): void;
}
export declare function buildProviderPool<M extends ProviderMap>(providers: M): ProviderPool<M>;
